
import "DToX._ContextMenu.ContextMenu";



local function countItems( menuItems, item )
   local n = menuItems:GetCount();
   item:SetText( ">> Contains items: " .. n );
end

-- Creates new menu (default or custom)
local function newMenu( bCustom )
   local menu;
   local menuItem;
   if ( bCustom ) then
      menu = Turbine.UI.ContextMenu2();
      menuItem = Turbine.UI.MenuItem2;
   else
      menu = Turbine.UI.ContextMenu();
      menuItem = Turbine.UI.MenuItem;
   end

   menuItems = menu:GetItems();

   -- Text, Enabled, Checked
   local item0 = menuItem( "", false, true );
   local item1 = menuItem( "Item 1. Don't close on click", true );
   function item1:Click()
      self.KeepOpen = "KOpen";
      local text = self:GetText();
      Turbine.Shell.WriteLine( ">> Clicked '" .. text .. "'." );
   end
   -- local item2 = menuItem( "Item 2", true, true );
   local item2 = menuItem( "Item 2", true, true );
   local item3 = menuItem( "Item 3", true, false );
   local item4 = menuItem( "Item 4. Disabled submenu", false );
   menuItems:Add( item0 );
   menuItems:Add( item1 );
   menuItems:Add( item2 );
   menuItems:Add( item3 );
   menuItems:Add( item4 );
countItems( menuItems, item0 );

   -- Custom images
   if ( bCustom ) then
      local icon = item3.Icon;
      icon:SetBackground( 0x41005E5B );
      -- icon:SetVisible( true ); -- Just show icon
      item3:SetChecked( true ); -- To use SetChecked and IsChecked function
      item3.Label:AppendText( ". Custom icon" );

      local icon = item4.Icon;
      icon:SetBackground( 0x410001D1 );
      icon.ScaleImage = true; -- To scale image
      item4:SetChecked( true );
   end

   -- Level 2
   local item2Submenu = item2:GetItems();
   local item20 = menuItem( "", false, true );
   local item21 = menuItem( "Item 21" );
   local item22 = menuItem( "Item 22" );
      item22:SetEnabled( false );
   local item23 = menuItem( "Item 23. Ромашка" );
   item2Submenu:Add( item20 );
   item2Submenu:Add( item21 );
   item2Submenu:Add( item22 );
   item2Submenu:Add( item23 );
countItems( item2Submenu, item20 );

   -- Level 2
   local item4Submenu = item4:GetItems();
   local item40 = menuItem( "", false, true );
   local item41 = menuItem( "Item 41" );
   local item42 = menuItem( "Item 42", false );
   item4Submenu:Add( item40 );
   item4Submenu:Add( item41 );
   item4Submenu:Add( item42 );
countItems( item4Submenu, item40 );

   -- Level 3
   local item23Submenu = item23:GetItems();
   local item231 = menuItem( "Item 231. Раз ромашка" );
   local item232 = menuItem( "Item 232. Два ромашка" );
   item23Submenu:Add( item231 );
   item23Submenu:Add( item232 );

   return menu;
end





-- Default context menu
local defaultMenu = newMenu();
-- Custom context menu
local customMenu = newMenu( true );
customMenu:SetFont( "Verdana16" ); -- To change item's font


window = Turbine.UI.Lotro.Window();
window:SetSize( 240, 100 );
window:SetPosition( 600, 300 );
window:SetText( "Click me" );
window:SetVisible( true );
-- Right = show custom menu. Else - default
function window:MouseClick( args )
   local btnPressed = args.Button;
   local btnExpected = Turbine.UI.MouseButton.Right;
   if ( btnPressed == btnExpected ) then
      customMenu:ShowMenu();
   else
      defaultMenu:ShowMenu();
   end
end

local label = Turbine.UI.Label();
label:SetParent( window );
label:SetPosition( 30, 35 );
label:SetSize( 200, 50 );
label:SetText( "Left mouse button click:\nshow default menu.\nRight mouse button click:\nshow custom menu." );
label:SetMouseVisible( false );
